## mingw-w64-z3-4.13.4-1.src.tar.zst

=== CMakeLists.txt ===
# Enforce some CMake policies
cmake_minimum_required(VERSION 3.16)

set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_compiler_flags_overrides.cmake")
project(Z3 VERSION 4.13.4.0 LANGUAGES CXX)

################################################################################
# Project version
################################################################################
set(Z3_FULL_VERSION_STR "${Z3_VERSION}") # Note this might be modified
message(STATUS "Z3 version ${Z3_VERSION}")

################################################################################
# Message for polluted source tree sanity checks
################################################################################
set(z3_polluted_tree_msg
  " should not exist and is polluting the source tree."
  " It is likely that this file came from the Python build system which"
  " generates files inside the source tree. This is bad practice and the CMake"
  " build system is setup to make sure that the source tree is clean during"
  " its configure step. If you are using git you can remove all untracked files"
  " using ``git clean -fx``. Be careful when doing this. You should probably use"
  " this with ``-n`` first to check which file(s) would be removed."
)

################################################################################
# Sanity check - Disallow building in source
################################################################################
if (PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
  message(FATAL_ERROR "In source builds are not allowed. You should invoke "
          "CMake from a different directory.")
endif()

################################################################################
# Add our CMake module directory to the list of module search directories
################################################################################
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/modules")

################################################################################
# Handle git hash and description
################################################################################
include(${PROJECT_SOURCE_DIR}/cmake/git_utils.cmake)
macro(disable_git_describe)
  if(Z3_INCLUDE_GIT_DESCRIBE)
    message(WARNING "Disabling Z3_INCLUDE_GIT_DESCRIBE")
    set(Z3_INCLUDE_GIT_DESCRIBE OFF CACHE BOOL "Include git describe output in version output" FORCE)
  endif()
endmacro()
macro(disable_git_hash)
  if(Z3_INCLUDE_GIT_HASH)
    message(WARNING "Disabling Z3_INCLUDE_GIT_HASH")
    set(Z3_INCLUDE_GIT_HASH OFF CACHE BOOL "Include git hash in version output" FORCE)
  endif()
endmacro()
option(Z3_INCLUDE_GIT_HASH "Include git hash in version output" ON)
option(Z3_INCLUDE_GIT_DESCRIBE "Include git describe output in version output" ON)

set(GIT_DIR "${PROJECT_SOURCE_DIR}/.git")
if ((Z3_INCLUDE_GIT_HASH OR Z3_INCLUDE_GIT_HASH) AND EXISTS "${GIT_DIR}")
  # Try to make CMake configure depend on the current git HEAD so that
  # a re-configure is triggered when the HEAD changes.
  add_git_dir_dependency("${GIT_DIR}" ADD_GIT_DEP_SUCCESS)
  if (ADD_GIT_DEP_SUCCESS)
    if (Z3_INCLUDE_GIT_HASH)
      get_git_head_hash("${GIT_DIR}" Z3GITHASH)
      if (NOT Z3GITHASH)
        message(WARNING "Failed to get Git hash")
        disable_git_hash()
      else()
        message(STATUS "Using Git hash in version output: ${Z3GITHASH}")
        # This mimics the behaviour of the old build system.
        set(Z3_FULL_VERSION_STR "${Z3_FULL_VERSION_STR} ${Z3GITHASH}")
      endif()
    else()
      message(STATUS "Not using Git hash in version output")
    endif()
    if (Z3_INCLUDE_GIT_DESCRIBE)
      get_git_head_describe("${GIT_DIR}" Z3_GIT_DESCRIPTION)
      if (NOT Z3_GIT_DESCRIPTION)
        message(WARNING "Failed to get Git description")
        disable_git_describe()
      endif()
      message(STATUS "Using Git description in version output: ${Z3_GIT_DESCRIPTION}")
      # This mimics the behaviour of the old build system.
      set(Z3_FULL_VERSION_STR "${Z3_FULL_VERSION_STR} ${Z3_GIT_DESCRIPTION}")
    else()
      message(STATUS "Not including git description in version")
    endif()
  else()
    message(WARNING "Failed to add git dependency.")
    disable_git_describe()
    disable_git_hash()
  endif()
else()
  message(STATUS "Failed to find git directory.")
  disable_git_describe()
  disable_git_hash()
endif()
if(NOT Z3_INCLUDE_GIT_HASH)
  unset(Z3GITHASH) # Used in configure_file()
endif()

################################################################################
# Useful CMake functions/Macros
################################################################################
include(CheckCXXSourceCompiles)
include(CMakeDependentOption)

################################################################################
# Compiler flags for Z3 components.
# Subsequent commands will append to this
################################################################################
set(Z3_COMPONENT_CXX_DEFINES "")
set(Z3_COMPONENT_CXX_FLAGS "")
set(Z3_COMPONENT_EXTRA_INCLUDE_DIRS "")
set(Z3_DEPENDENT_LIBS "")
set(Z3_DEPENDENT_EXTRA_CXX_LINK_FLAGS "")

################################################################################
# Build type
################################################################################
message(STATUS "CMake generator: ${CMAKE_GENERATOR}")
set(available_build_types Debug Release RelWithDebInfo MinSizeRel)
if (DEFINED CMAKE_CONFIGURATION_TYPES)
  # Multi-configuration build (e.g. Visual Studio and Xcode). Here
  # CMAKE_BUILD_TYPE doesn't matter
  message(STATUS "Available configurations: ${CMAKE_CONFIGURATION_TYPES}")
else()
  # Single configuration generator (e.g. Unix Makefiles, Ninja)
  if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "CMAKE_BUILD_TYPE is not set. Setting default")
    message(STATUS "The available build types are: ${available_build_types}")
    set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
        "Options are ${available_build_types}"
        FORCE)
    # Provide drop down menu options in cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${available_build_types})
  endif()
  message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

  # Check the selected build type is valid
  list(FIND available_build_types "${CMAKE_BUILD_TYPE}" _build_type_index)
  if ("${_build_type_index}" EQUAL "-1")
    message(FATAL_ERROR "\"${CMAKE_BUILD_TYPE}\" is an invalid build type.\n"
      "Use one of the following build types ${available_build_types}")
  endif()
endif()

# CMAKE_BUILD_TYPE has no meaning for multi-configuration generators
# (e.g. Visual Studio) so use generator expressions instead to add
# the right definitions when doing a particular build type.
#
# Note for some reason we have to leave off ``-D`` here otherwise
# we get ``-D-DZ3DEBUG`` passed to the compiler
list(APPEND Z3_COMPONENT_CXX_DEFINES $<$<CONFIG:Debug>:Z3DEBUG>)
list(APPEND Z3_COMPONENT_CXX_DEFINES $<$<CONFIG:Release>:_EXTERNAL_RELEASE>)
list(APPEND Z3_COMPONENT_CXX_DEFINES $<$<CONFIG:RelWithDebInfo>:_EXTERNAL_RELEASE>)

################################################################################
# Find Python
################################################################################
find_package(Python3 REQUIRED COMPONENTS Interpreter)
message(STATUS "Python3_EXECUTABLE: ${Python3_EXECUTABLE}")

################################################################################
# Target architecture detection
################################################################################
include(${PROJECT_SOURCE_DIR}/cmake/target_arch_detect.cmake)
detect_target_architecture(TARGET_ARCHITECTURE)
message(STATUS "Detected target architecture: ${TARGET_ARCHITECTURE}")


################################################################################
# Function for detecting C++ compiler flag support
################################################################################
include(${PROJECT_SOURCE_DIR}/cmake/z3_add_cxx_flag.cmake)

################################################################################
# C++ language version
################################################################################
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

################################################################################
# Platform detection
################################################################################
if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  if (TARGET_ARCHITECTURE STREQUAL "arm64")
    set(CMAKE_OSX_ARCHITECTURES "arm64")
  endif()
elseif (WIN32)
  message(STATUS "Platform: Windows")
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_WINDOWS")
  # workaround for #7420
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR")  
elseif (EMSCRIPTEN)
  message(STATUS "Platform: Emscripten")
  list(APPEND Z3_DEPENDENT_EXTRA_CXX_LINK_FLAGS
    "-Os"
    "-s ALLOW_MEMORY_GROWTH=1"
    "-s ASSERTIONS=0"
    "-s DISABLE_EXCEPTION_CATCHING=0"
    "-s ERROR_ON_UNDEFINED_SYMBOLS=1"
  )
endif()

list(APPEND Z3_COMPONENT_EXTRA_INCLUDE_DIRS
  "${PROJECT_BINARY_DIR}/src"
  "${PROJECT_SOURCE_DIR}/src"
)

################################################################################
# GNU multiple precision library support
################################################################################
option(Z3_USE_LIB_GMP "Use GNU Multiple Precision Library" OFF)
if (Z3_USE_LIB_GMP)
  # Because this is off by default we will make the configure fail if libgmp
  # can't be found
  find_package(GMP REQUIRED)
  message(STATUS "Using libgmp")
  list(APPEND Z3_DEPENDENT_LIBS GMP::GMP)
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_MP_GMP")
else()
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_MP_INTERNAL")
  message(STATUS "Not using libgmp")
endif()


################################################################################
# API Log sync
################################################################################
option(Z3_API_LOG_SYNC
  "Use locking when logging Z3 API calls (experimental)"
  OFF
)
if (Z3_API_LOG_SYNC)
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-DZ3_LOG_SYNC")
  message(STATUS "Using Z3_API_LOG_SYNC")
else()
  message(STATUS "Not using Z3_API_LOG_SYNC")
endif()

################################################################################
# Thread safe or not?
################################################################################
option(Z3_SINGLE_THREADED
  "Non-thread-safe build"
  OFF
)
if (Z3_SINGLE_THREADED)
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-DSINGLE_THREAD")
  message(STATUS "Non-thread-safe build")
else()
  message(STATUS "Thread-safe build")
endif()


################################################################################
# Use polling based timeout. This avoids spawning threads for timer tasks
################################################################################
option(Z3_POLLING_TIMER
  "Use polling based timeout checks"
  OFF
)
if (Z3_POLLING_TIMER)
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-DPOLLING_TIMER")
  message(STATUS "Polling based timer")
endif()



################################################################################
# FP math
################################################################################
# FIXME: Support ARM "-mfpu=vfp -mfloat-abi=hard"
if ((TARGET_ARCHITECTURE STREQUAL "x86_64") OR (TARGET_ARCHITECTURE STREQUAL "i686"))
  if ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang") OR (CMAKE_CXX_COMPILER_ID MATCHES "Intel"))
    set(SSE_FLAGS "-mfpmath=sse" "-msse" "-msse2")
  elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(SSE_FLAGS "/arch:SSE2")
  else()
    message(FATAL_ERROR "Unknown compiler ${CMAKE_CXX_COMPILER_ID}")
  endif()
  CHECK_CXX_COMPILER_FLAG("${SSE_FLAGS}" HAS_SSE2)
  if (HAS_SSE2)
    list(APPEND Z3_COMPONENT_CXX_FLAGS ${SSE_FLAGS})
  endif()
  unset(SSE_FLAGS)
endif()

=== src/params/CMakeLists.txt ===
z3_add_component(params
  SOURCES
    pattern_inference_params.cpp
    context_params.cpp
  COMPONENT_DEPENDENCIES
    util
  PYG_FILES
    arith_rewriter_params.pyg
    array_rewriter_params.pyg
    bool_rewriter_params.pyg
    bv_rewriter_params.pyg
    fpa_rewriter_params.pyg
    fpa2bv_rewriter_params.pyg
    pattern_inference_params_helper.pyg
    poly_rewriter_params.pyg
    rewriter_params.pyg
    sat_params.pyg
    seq_rewriter_params.pyg
    sls_params.pyg
    solver_params.pyg
    tactic_params.pyg
  EXTRA_REGISTER_MODULE_HEADERS
    context_params.h
)

=== src/sat/CMakeLists.txt ===
z3_add_component(sat
  SOURCES
    dimacs.cpp
    sat_aig_cuts.cpp
    sat_aig_finder.cpp
    sat_anf_simplifier.cpp
    sat_asymm_branch.cpp
    sat_bcd.cpp
    sat_big.cpp
    sat_binspr.cpp
    sat_clause.cpp
    sat_clause_set.cpp
    sat_clause_use_list.cpp
    sat_cleaner.cpp
    sat_config.cpp
    sat_cut_simplifier.cpp
    sat_cutset.cpp
    sat_ddfw_wrapper.cpp    
    sat_drat.cpp
    sat_elim_eqs.cpp
    sat_elim_vars.cpp
    sat_gc.cpp
    sat_integrity_checker.cpp
    sat_local_search.cpp
    sat_lookahead.cpp
    sat_lut_finder.cpp
    sat_model_converter.cpp
    sat_mus.cpp
    sat_npn3_finder.cpp
    sat_parallel.cpp
    sat_prob.cpp
    sat_probing.cpp
    sat_proof_trim.cpp
    sat_scc.cpp
    sat_simplifier.cpp
    sat_solver.cpp
    sat_watched.cpp
    sat_xor_finder.cpp
  COMPONENT_DEPENDENCIES
    util
    dd
    grobner
    params
  PYG_FILES
    sat_asymm_branch_params.pyg
    sat_scc_params.pyg
    sat_simplifier_params.pyg
)

=== src/smt/CMakeLists.txt ===
z3_add_component(smt
  SOURCES
    arith_eq_adapter.cpp
    arith_eq_solver.cpp
    dyn_ack.cpp
    expr_context_simplifier.cpp
    fingerprints.cpp
    mam.cpp
    old_interval.cpp
    qi_queue.cpp
    seq_axioms.cpp
    seq_eq_solver.cpp
    seq_ne_solver.cpp
    seq_offset_eq.cpp
    seq_regex.cpp
    smt_almost_cg_table.cpp
    smt_arith_value.cpp
    smt_case_split_queue.cpp
    smt_cg_table.cpp
    smt_checker.cpp
    smt_clause.cpp
    smt_clause_proof.cpp
    smt_conflict_resolution.cpp
    smt_consequences.cpp
    smt_context.cpp
    smt_context_inv.cpp
    smt_context_pp.cpp
    smt_context_stat.cpp
    smt_enode.cpp
    smt_farkas_util.cpp
    smt_for_each_relevant_expr.cpp
    smt_implied_equalities.cpp
    smt_internalizer.cpp
    smt_justification.cpp
    smt_kernel.cpp
    smt_literal.cpp
    smt_lookahead.cpp
    smt_model_checker.cpp
    smt_model_finder.cpp
    smt_model_generator.cpp
    smt_parallel.cpp
    smt_quantifier.cpp
    smt_quick_checker.cpp
    smt_relevancy.cpp
    smt_setup.cpp
    smt_solver.cpp
    smt_statistics.cpp
    smt_theory.cpp
    smt_value_sort.cpp
    smt2_extra_cmds.cpp
    theory_arith.cpp
    theory_array_bapa.cpp
    theory_array_base.cpp
    theory_array.cpp
    theory_array_full.cpp
    theory_bv.cpp
    theory_char.cpp
    theory_datatype.cpp
    theory_dense_diff_logic.cpp
    theory_diff_logic.cpp
    theory_dl.cpp
    theory_dummy.cpp
    theory_fpa.cpp
    theory_intblast.cpp
    theory_lra.cpp
    theory_opt.cpp
    theory_pb.cpp
    theory_recfun.cpp
    theory_seq.cpp
    theory_sls.cpp
    theory_special_relations.cpp
    theory_str.cpp
    theory_str_mc.cpp
    theory_str_regex.cpp
    theory_user_propagator.cpp
    theory_utvpi.cpp
    theory_wmaxsat.cpp
    uses_theory.cpp
    watch_list.cpp
  COMPONENT_DEPENDENCIES
    solver_assertions
    bit_blaster
    cmd_context
    fpa
    grobner
    nlsat
    lp
    macros
    normal_forms
    parser_util
    pattern
    proofs
    proto_model
    simplex
    substitution
)

=== src/test/CMakeLists.txt ===
add_subdirectory(fuzzing)
add_subdirectory(lp)
################################################################################
# z3-test executable
################################################################################
set(z3_test_deps api fuzzing simplex)
z3_expand_dependencies(z3_test_expanded_deps ${z3_test_deps})
set (z3_test_extra_object_files "")
foreach (component ${z3_test_expanded_deps})
  list(APPEND z3_test_extra_object_files $<TARGET_OBJECTS:${component}>)
endforeach()
add_executable(test-z3
  EXCLUDE_FROM_ALL
  algebraic.cpp
  api_bug.cpp
  api.cpp
  arith_rewriter.cpp
  arith_simplifier_plugin.cpp
  ast.cpp
  bdd.cpp
  bit_blaster.cpp
  bits.cpp
  bit_vector.cpp
  buffer.cpp
  chashtable.cpp
  check_assumptions.cpp
  cnf_backbones.cpp
  cube_clause.cpp
  datalog_parser.cpp
  ddnf.cpp
  diff_logic.cpp
  distribution.cpp
  dl_context.cpp
  dl_product_relation.cpp
  dl_query.cpp
  dl_relation.cpp
  dl_table.cpp
  dl_util.cpp
  doc.cpp  
  dlist.cpp
  egraph.cpp
  escaped.cpp
  euf_bv_plugin.cpp
  euf_arith_plugin.cpp
  ex.cpp
  expr_rand.cpp
  expr_substitution.cpp
  ext_numeral.cpp
  f2n.cpp
  factor_rewriter.cpp
  finder.cpp
  fixed_bit_vector.cpp
  for_each_file.cpp
  get_consequences.cpp
  get_implied_equalities.cpp
  "${CMAKE_CURRENT_BINARY_DIR}/gparams_register_modules.cpp"
  hashtable.cpp
  heap.cpp
  heap_trie.cpp
  hilbert_basis.cpp
  horn_subsume_model_converter.cpp
  hwf.cpp
  inf_rational.cpp
  "${CMAKE_CURRENT_BINARY_DIR}/install_tactic.cpp"
  interval.cpp
  karr.cpp
  list.cpp
  main.cpp
  map.cpp
  matcher.cpp
  "${CMAKE_CURRENT_BINARY_DIR}/mem_initializer.cpp"
  memory.cpp
  model2expr.cpp
  model_based_opt.cpp
  model_evaluator.cpp
  model_retrieval.cpp
  mpbq.cpp
  mpf.cpp
  mpff.cpp
  mpfx.cpp
  mpq.cpp
  mpz.cpp
  nlarith_util.cpp
  nlsat.cpp
  no_overflow.cpp
  object_allocator.cpp
  old_interval.cpp
  optional.cpp
  parray.cpp
  pb2bv.cpp
  pdd.cpp
  pdd_solver.cpp
  permutation.cpp
  polynomial.cpp
  polynorm.cpp
  prime_generator.cpp
  proof_checker.cpp
  qe_arith.cpp
  quant_elim.cpp
  quant_solve.cpp
  random.cpp
  rational.cpp
  rcf.cpp
  region.cpp
  sat_local_search.cpp
  sat_lookahead.cpp
  sat_user_scope.cpp
  scoped_timer.cpp
  scoped_vector.cpp
  simple_parser.cpp
  simplex.cpp
  simplifier.cpp
  sls_test.cpp
  sls_seq_plugin.cpp
  small_object_allocator.cpp
  smt2print_parse.cpp
  smt_context.cpp
  solver_pool.cpp
  sorting_network.cpp
  stack.cpp
  string_buffer.cpp
  substitution.cpp
  symbol.cpp
  symbol_table.cpp
  tbv.cpp
  theory_dl.cpp
  theory_pb.cpp
  timeout.cpp
  total_order.cpp
  totalizer.cpp
  trigo.cpp
  udoc_relation.cpp
  uint_set.cpp
  upolynomial.cpp
  value_generator.cpp
  value_sweep.cpp
  var_subst.cpp
  vector.cpp
  lp/lp.cpp
  lp/nla_solver_test.cpp
  zstring.cpp
  ${z3_test_extra_object_files}
)
z3_add_install_tactic_rule(${z3_test_deps})
z3_add_memory_initializer_rule(${z3_test_deps})
z3_add_gparams_register_modules_rule(${z3_test_deps})
target_compile_definitions(test-z3 PRIVATE ${Z3_COMPONENT_CXX_DEFINES})
target_compile_options(test-z3 PRIVATE ${Z3_COMPONENT_CXX_FLAGS})
target_link_libraries(test-z3 PRIVATE ${Z3_DEPENDENT_LIBS})
target_include_directories(test-z3 PRIVATE ${Z3_COMPONENT_EXTRA_INCLUDE_DIRS})
z3_append_linker_flag_list_to_target(test-z3 ${Z3_DEPENDENT_EXTRA_CXX_LINK_FLAGS})
z3_add_component_dependencies_to_target(test-z3 ${z3_test_expanded_deps})

=== src/ast/sls/CMakeLists.txt ===
z3_add_component(ast_sls
  SOURCES
    bvsls_opt_engine.cpp
    sat_ddfw.cpp
    sls_arith_base.cpp
    sls_arith_plugin.cpp
    sls_array_plugin.cpp
    sls_basic_plugin.cpp
    sls_bv_engine.cpp
    sls_bv_eval.cpp
    sls_bv_fixed.cpp
    sls_bv_plugin.cpp
    sls_bv_terms.cpp
    sls_bv_valuation.cpp
    sls_context.cpp
    sls_datatype_plugin.cpp
    sls_euf_plugin.cpp
    sls_seq_plugin.cpp
    sls_smt_plugin.cpp
    sls_smt_solver.cpp    
  COMPONENT_DEPENDENCIES
    ast
    euf
    converters
    normal_forms
)

=== src/sat/smt/CMakeLists.txt ===
z3_add_component(sat_smt
  SOURCES
    arith_axioms.cpp
    arith_diagnostics.cpp
    arith_internalize.cpp
    arith_solver.cpp
    arith_value.cpp
    array_axioms.cpp
    array_diagnostics.cpp
    array_internalize.cpp
    array_model.cpp
    array_solver.cpp
    atom2bool_var.cpp
    bv_ackerman.cpp
    bv_delay_internalize.cpp
    bv_internalize.cpp
    bv_invariant.cpp
    bv_solver.cpp
    bv_theory_checker.cpp
    dt_solver.cpp
    euf_ackerman.cpp
    euf_internalize.cpp
    euf_invariant.cpp
    euf_model.cpp
    euf_proof.cpp
    euf_proof_checker.cpp
    euf_relevancy.cpp
    euf_solver.cpp
    intblast_solver.cpp
    fpa_solver.cpp
    pb_card.cpp
    pb_constraint.cpp
    pb_internalize.cpp
    pb_pb.cpp
    pb_solver.cpp
    q_clause.cpp
    q_ematch.cpp
    q_eval.cpp
    q_mam.cpp
    q_mbi.cpp
    q_model_fixer.cpp
    q_theory_checker.cpp
    q_queue.cpp
    q_solver.cpp
    recfun_solver.cpp
    sat_th.cpp
    sls_solver.cpp
    specrel_solver.cpp
    tseitin_theory_checker.cpp
    user_solver.cpp
  COMPONENT_DEPENDENCIES
    sat
    ast
    euf
    mbp
    smt_params
)

=== PKGBUILD ===
# Maintainer: Some One <some.one@some.email.com>

_realname=z3
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=4.13.4
pkgrel=1
pkgdesc="Z3 is a high-performance theorem prover being developed at Microsoft Research (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/Z3Prover/z3"
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         $([[ ${CARCH} == i686 ]] || echo "${MINGW_PACKAGE_PREFIX}-gmp"))
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python"
             $([[ ${CARCH} == i686 ]] || echo \
               "${MINGW_PACKAGE_PREFIX}-python-build" \
               "${MINGW_PACKAGE_PREFIX}-python-installer" \
               "${MINGW_PACKAGE_PREFIX}-python-setuptools"))
source=("https://github.com/Z3Prover/z3/archive/z3-${pkgver}.tar.gz"
        001-mingw-fixes.patch
        003-fix-dll-exports.patch
        004-fix-python-bindings-install.patch)
sha256sums=('4071977e66e9f3d239b7b098ceddfe62ffdf3c71e345e9524a4a5001d1f4adf3'
            'dff9754409a077d0ae49f1bfb2404bd5b318d301273844a80649a9e20e61e2fa'
            'ce01668afae8e60c32a0d7937d3f8f67a7dc23aa4270913d157e676d061dfe6a'
            'a1c96b734e71d4cffc5d55f8a9ed5cc823ac87a8fcb6691a84a23a201398a398')

apply_patch_with_msg() {
  for _fname in "$@"
  do
    msg2 "Applying ${_fname}"
    patch -Nbp1 -i "${srcdir}"/${_fname}
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${_realname}-${pkgver}
  apply_patch_with_msg \
    001-mingw-fixes.patch \
    003-fix-dll-exports.patch \
    004-fix-python-bindings-install.patch
}

build() {
  local -a extra_config
  if check_option "debug" "y"; then
    extra_config+=(-DCMAKE_BUILD_TYPE=Debug)
    VERBOSE="VERBOSE=1"
  else
    extra_config+=(-DCMAKE_BUILD_TYPE=Release)
  fi

  mkdir -p "${srcdir}"/build-${MSYSTEM}-static && cd "${srcdir}"/build-${MSYSTEM}-static

  msg "Build static z3"
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DZ3_BUILD_LIBZ3_SHARED=OFF \
    -DZ3_BUILD_TEST_EXECUTABLES=OFF \
    -DZ3_INCLUDE_GIT_HASH=OFF \
    -DZ3_INCLUDE_GIT_DESCRIBE=OFF \
    -DZ3_ENABLE_EXAMPLE_TARGETS=OFF \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
    "${extra_config[@]}" \
    ../${_realname}-${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./

  mkdir -p "${srcdir}"/build-${MSYSTEM}-shared && cd "${srcdir}"/build-${MSYSTEM}-shared

  if [[ ${CARCH} == i686 ]]; then
    extra_config+=("-DZ3_BUILD_PYTHON_BINDINGS=OFF" "-DZ3_USE_LIB_GMP=OFF")
  else
    extra_config+=("-DZ3_BUILD_PYTHON_BINDINGS=ON" "-DZ3_USE_LIB_GMP=ON")
  fi

  msg "Build shared z3"
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DZ3_BUILD_LIBZ3_SHARED=ON \
    -DZ3_BUILD_TEST_EXECUTABLES=OFF \
    -DZ3_INCLUDE_GIT_HASH=OFF \
    -DZ3_INCLUDE_GIT_DESCRIBE=OFF \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
    "${extra_config[@]}" \
    ../${_realname}-${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

check() {
 cd "${srcdir}"/build-${MSYSTEM}-shared
 ${MINGW_PREFIX}/bin/ctest.exe test-z3 || true
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}-static
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install .

  cd "${srcdir}"/build-${MSYSTEM}-shared
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install .

  if [[ ${CARCH} != i686 ]]; then
    MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
      -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib/python"*
  fi

  install -Dm644 "${srcdir}"/${_realname}-${_realname}-${pkgver}/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.txt
}
